#include "Arduino.h"
#include "Edushield.h"
#include <SoftwareSerial.h>



// Definování barev pro RGB ledku
#define Red       "100"
#define Blue      "001"
#define Green     "010"
#define Yellow    "110"
#define Magenta   "101"
#define Cyan      "011"
#define White     "111"
#define None      "000"


//konstruktor
Edushield::Edushield()
{
  //Piny pro RGB ledku
  RGBPin_Red = 9;
  RGBPin_Blue = 6;
  RGBPin_Green = 5;
  
  pinMode(RGBPin_Red, OUTPUT);
  pinMode(RGBPin_Blue, OUTPUT);
  pinMode(RGBPin_Green, OUTPUT);


  //piny pro ledky    
   pinMode(A2, OUTPUT);
   pinMode(13, OUTPUT);
   pinMode(A3, OUTPUT);

   //pin pro tlačítko
   button = 6;
   pinMode(button,INPUT);
}

//Metody pro ovládání RGB ledky--------------------------------
void Edushield::RGBsetToNone(){
   digitalWrite(RGBPin_Red,   1);
   digitalWrite(RGBPin_Green, 1);
   digitalWrite(RGBPin_Blue,  1);
}

void Edushield::RGBsetColor(char input[]){
  if(input[0] ==   '1'){
    digitalWrite(RGBPin_Red,0);
  }else{
        digitalWrite(RGBPin_Red,1);
  }
   if(input[1] ==  '1'){
     digitalWrite(RGBPin_Green,0);
  }else{
     digitalWrite(RGBPin_Green,1);
    }
  if(input[2] == '1'){
    digitalWrite(RGBPin_Blue, 0);
  }else{
     digitalWrite(RGBPin_Blue, 1);

  }
}

void  Edushield::RGBsetToRed(){
  RGBsetColor(Red);
}

void  Edushield::RGBsetToBlue(){
  RGBsetColor(Blue);
}

void  Edushield::RGBsetToYellow(){
  RGBsetColor(Yellow);
}

void  Edushield::RGBsetToGreen(){
  RGBsetColor(Green);
}

void  Edushield::RGBsetToWhite(){
  RGBsetColor(White);
}

void  Edushield::RGBsetToMagenta(){
  RGBsetColor(Magenta);
}

void  Edushield::RGBsetToCyan(){
  RGBsetColor(Cyan);
}

//Metody pro ovládání jednobarevných ledek -------------------------------------- 
void Edushield::ledRed_ON(){
  digitalWrite(A2, HIGH);
}

void Edushield::ledRed_OFF(){
  digitalWrite(A2, LOW);
}

void Edushield::ledGreen_ON(){
  digitalWrite(13, HIGH);
}

void Edushield::ledGreen_OFF(){
  digitalWrite(13, LOW);
}

void Edushield::ledYellow_ON(){
  analogWrite(A3, 1024);
}

void Edushield::ledYellow_OFF(){
  analogWrite(A3, 0);
}

void Edushield::ledAll_ON(){
  ledRed_ON();
  ledGreen_ON();
  ledYellow_ON();
}

void Edushield::ledAll_OFF(){
  ledRed_OFF();
  ledGreen_OFF();
  ledYellow_OFF();
}

//Tklačítko ---------------------------

int  Edushield::buttonPress(){
  int counter = 0;
  int timer = 0;
  while(timer <= 3000){
    timer += 10;
    if(digitalRead(6) == HIGH){
      counter++;
    }
    delay(10);
  }
  if(counter == 0){
    return 0;
  }else if(counter <= 150){
    return 1;
  }else if (counter > 150){
    return 2;
  }
}

